package com.telpo.dipperposition.common;

import tools.CommonTools;

import java.time.LocalTime;
import java.time.format.DateTimeFormatter;

/**
 * @program: DataPushServer
 * @description: 时间工具类
 * @author: linwl
 * @create: 2020-08-05 11:16
 */
public class TimeTools {

  private TimeTools() {}

  /**
   * 校验时间段
   *
   * @param startTime 起始时间 HH:mm
   * @param endTime 结束时间 HH:mm
   * @return
   */
  public static boolean checkTime(String startTime, String endTime) {
    boolean result = false;
    DateTimeFormatter dateTimeFormatter = DateTimeFormatter.ofPattern("HH:mm");
    LocalTime pushStartTime = LocalTime.parse(startTime, dateTimeFormatter);
    LocalTime pushEndTime = LocalTime.parse(endTime, dateTimeFormatter);
    LocalTime zeroTime = LocalTime.parse("00:00");
    if (zeroTime.equals(pushEndTime)) {
      pushEndTime = pushEndTime.plusNanos(-10);
    }
    if (CommonTools.checkInTime(pushStartTime, pushEndTime)) {
      result = true;
    }
    return result;
  }
}
