package com.telpo.dipperposition.service.impl;

import com.telpo.dipperposition.entity.mongo.IPProvinceEntity;
import com.telpo.dipperposition.mapper.IPProvinceMapper;
import com.telpo.dipperposition.service.IPProvinceService;
import com.telpo.dipperposition.vo.IPProvinceVo;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @program: DataPushServer
 * @description: 推送记录服务接口实现类
 * @author: linwl
 * @create: 2020-07-20 11:09
 */
@Slf4j
@Service
public class IPProvinceServiceImpl implements IPProvinceService {

  @Autowired
  private IPProvinceMapper iPProvinceMapper;

  @Override
  public boolean saveIPProvince(IPProvinceEntity entity) {
    iPProvinceMapper.save(entity);
    return true;
  }

  @Override
  public boolean updateIPProvince(
          IPProvinceEntity query, IPProvinceEntity update) {
    iPProvinceMapper.updateFirst(query, update);
    return true;
  }

  @Override
  public boolean romveById(String id) {
    iPProvinceMapper.deleteById(id);
    return false;
  }

  @Override
  public IPProvinceEntity getIPProvince(String ipAddress) {
    try {
      IPProvinceEntity query = new IPProvinceEntity();
      query.setIp(ipAddress);
      List<IPProvinceEntity> pushRecords = iPProvinceMapper.queryList(query);
      if (ObjectUtils.isNotEmpty(pushRecords)) {
        return pushRecords.get(0);
      } else {
        return null;
      }
    } catch (Exception e) {
      log.error("获取IP省份异常:", e);
      return null;
    }
  }
}
